/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: SimpleLocation.java,v 58b34b45c683 2010/04/25 00:44:54 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.observation.simple;

import javax.annotation.Nonnull;
import java.util.Locale;
import java.util.Map;
import java.util.SortedSet;
import java.io.Serializable;
import it.tidalwave.util.DefaultDisplayable;
import it.tidalwave.bluebill.observation.Finder;
import it.tidalwave.bluebill.observation.Location;
import it.tidalwave.bluebill.observation.Observation;
import it.tidalwave.bluebill.observation.ObservationItem;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class SimpleLocation extends AsSupport implements Location, Serializable
  {
    private static final long serialVersionUID = 768675648437593487L;

    private final DefaultDisplayable displayable;

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public SimpleLocation (final @Nonnull String displayName,
                           final @Nonnull Object ... capabilities)
      {
        super(capabilities);
        displayable = new DefaultDisplayable(displayName, "DefaultLocation");
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public Finder<ObservationItem> findObservationItems()
      {
        throw new UnsupportedOperationException("Not supported yet.");
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public Finder<Observation> findObservations()
      {
        throw new UnsupportedOperationException("Not supported yet.");
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public String getDisplayName()
      {
        return displayable.getDisplayName();
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public String getDisplayName (Locale locale)
      {
        return displayable.getDisplayName(locale);
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public Map<Locale, String> getDisplayNames()
      {
        return displayable.getDisplayNames();
      }

    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    public SortedSet<Locale> getLocales()
      {
        return displayable.getLocales();
      }
  }
